import Rand from './Rand';
export declare const DEFAULT_DRUNK_STEP = 0.1;
export type DrunkOptions = {
    max?: number;
    min?: number;
    startsAt?: number;
    step?: number;
};
export type DrunkState = {
    initialValue: number;
    max: number;
    min: number;
    step: number;
    value: number;
};
export declare const parseStepSize: (step?: number) => number;
export declare const parseOptions: (opts?: DrunkOptions) => DrunkOptions;
export default class Drunk {
    state: DrunkState;
    protected _initialValue: Rand;
    protected _step: Rand;
    constructor(opts?: DrunkOptions);
    setRange(partialOpts?: Pick<DrunkOptions, 'min' | 'max'>): void;
    setStepSize(partialOpts?: Pick<DrunkOptions, 'step'>): void;
    reset(opts?: DrunkOptions): void;
    value(): number;
    next(): number;
}
