import Scale from './Scale';
export type EnvOptions = {
    duration: number;
    from?: number;
    to?: number;
};
export type EnvState = {
    duration: number;
    from: number;
    prev: number;
    to: number;
    totalElapsed: number;
    value: number;
};
export declare const parseOptions: (opts?: EnvOptions) => EnvOptions;
export declare const getDerivedStateFromOptions: (opts: EnvOptions | undefined, prevState: EnvState) => EnvState;
export default class Env {
    state: EnvState;
    protected _interpolator: Scale;
    constructor(opts: EnvOptions);
    setDuration(duration: number): void;
    reset(opts?: EnvOptions): void;
    hasFinished(): boolean;
    value(): number;
    next(): number;
}
