"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseOptions = void 0;
const clamp_1 = __importDefault(require("./clamp"));
const parseOptions = (opts) => {
    return Object.assign({ min: 0, max: 1 }, opts);
};
exports.parseOptions = parseOptions;
class Rand {
    static rand(opts) {
        return new Rand(opts).value();
    }
    constructor(opts) {
        const { min, max } = (0, exports.parseOptions)(opts);
        this.state = { max, min, value: undefined };
        this.next();
    }
    setRange(partialOpts) {
        const { min, max } = Object.assign(Object.assign({}, this.state), partialOpts);
        this.state = Object.assign(Object.assign({}, this.state), { max,
            min, value: (0, clamp_1.default)(this.state.value, min, max) });
    }
    value() {
        return this.state.value;
    }
    next() {
        const { min, max } = this.state;
        const value = Math.random() * (max - min) + min;
        this.state.value = value;
        return value;
    }
}
exports.default = Rand;
