export type ScaleRange = {
    min?: number;
    max: number;
};
export type ScaleOptions = {
    from?: ScaleRange;
    to?: ScaleRange;
};
export type ScaleState = {
    from: ScaleRange;
    to: ScaleRange;
    value: number | undefined;
};
export declare const parseOptions: (opts?: ScaleOptions) => ScaleOptions;
export declare const getDerivedStateFromOptions: (opts: ScaleOptions, prevState: ScaleState) => ScaleState;
export default class Scale {
    state: ScaleState;
    static scale(n: number, opts?: ScaleOptions): number;
    constructor(opts?: ScaleOptions);
    setRanges(opts: ScaleOptions): void;
    reset(opts: ScaleOptions): void;
    value(): number;
    scale(n: number): number;
}
