"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseOptions = exports.DEFAULT_FPS = void 0;
const ms_1 = __importDefault(require("../utils/ms"));
const Metro_1 = __importDefault(require("./Metro"));
exports.DEFAULT_FPS = 60;
const parseOptions = (opts) => {
    const { fps } = Object.assign({ fps: exports.DEFAULT_FPS }, opts);
    return {
        time: (0, ms_1.default)(fps, "fps" /* TimeFormat.FPS */),
    };
};
exports.parseOptions = parseOptions;
class Frames extends Metro_1.default {
    constructor(callback, opts) {
        super(callback, (0, exports.parseOptions)(opts));
        this.setFPS = (fps = exports.DEFAULT_FPS) => {
            this.setTime((0, ms_1.default)(fps, "fps" /* TimeFormat.FPS */));
        };
    }
    asyncHandler(callback) {
        if (typeof window === 'undefined') {
            super.asyncHandler(callback);
        }
        else {
            this._timerId = requestAnimationFrame(callback);
        }
    }
    clearAsyncHandler() {
        if (typeof window === 'undefined') {
            super.clearAsyncHandler();
        }
        else {
            cancelAnimationFrame(this._timerId);
        }
    }
}
exports.default = Frames;
