export type MetroOptions = {
    time?: number;
};
export type TimerState = {
    initialTime: number;
    isRunning: boolean;
    iterations: number;
    prev: number;
    tickInterval: number;
    time: number;
    totalElapsed: number;
};
export type TimerCallback<TimerApi extends Metro> = (timer: TimerApi) => void;
export declare const getInitialState: (initialTime: number) => TimerState;
export declare const parseOptions: (opts?: MetroOptions) => MetroOptions;
export declare const processTimerState: (state: TimerState, callback: (state: TimerState) => void) => TimerState;
export default class Metro {
    state: TimerState;
    protected _listeners: TimerCallback<Metro>[];
    protected _timerId: ReturnType<typeof setTimeout> | number;
    constructor(callback: TimerCallback<Metro>, opts?: MetroOptions);
    asyncHandler(callback: () => void): void;
    clearAsyncHandler(): void;
    stop: () => number;
    reset: () => void;
    setTime: (updatedTime?: number) => void;
    run: () => void;
}
